//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_level1  0

//
//
//
//
//

extern string  TimeFrame         = "Current time frame";
extern int     MacdFast          = 12;
extern int     MacdSlow          = 26;
extern int     MacdPrice         = PRICE_CLOSE;
extern string  FirstSymbol       = "";
extern string  SecondSymbol      = "GBPUSD";
extern bool    Interpolate       = true;
extern string  UniqueID          = "MACDDifferentPairs";
extern color   FirstSymbolColor  = DeepSkyBlue;
extern color   SecondSymbolColor = PaleVioletRed;

//
//
//
//
//

double buffer1[];
double buffer2[];

//
//
//
//
//

string indicatorScreenName;
string indicatorFileName;
bool   returnBars;
int    timeFrame;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//

int init()
{
   if (FirstSymbol == "" ) FirstSymbol = Symbol();
      SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_LINE,EMPTY,EMPTY,FirstSymbolColor);
      SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_LINE,EMPTY,EMPTY,SecondSymbolColor);

      //
      //
      //
      //
      //
      
      indicatorFileName   = WindowExpertName();
      returnBars          = (TimeFrame=="returnBars");
      timeFrame           = stringToTimeFrame(TimeFrame);
      indicatorScreenName = UniqueID+" "+timeFrameToString(timeFrame)+" MACD ("+MacdFast+","+MacdSlow+","+FirstSymbol+","+SecondSymbol+") ";
   IndicatorShortName(indicatorScreenName);
   return(0);
}

//
//
//
//
//

int deinit()
{
   string lookFor       = UniqueID+":";
   int    lookForLength = StringLen(lookFor);
   for (int i = ObjectsTotal() - 1; i >= 0; i--)
   {
      string name = ObjectName(i); if (StringSubstr(name, 0, lookForLength) == name) ObjectDelete(name);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,y,limit,counted_bars=IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { buffer1[0] = limit; return(0); }
           if (FirstSymbol  != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(FirstSymbol ,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
           if (SecondSymbol != Symbol() || timeFrame > Period()) limit = MathMax(limit,MathMin(Bars-1,iCustom(SecondSymbol,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

           //
           //
           //
           //
           //
           
           showSymbol("1",FirstSymbol ,10,FirstSymbolColor);
           showSymbol("2",SecondSymbol,22,SecondSymbolColor);

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      y = iBarShift(FirstSymbol ,timeFrame,Time[i]); buffer1[i] = iMACD(FirstSymbol ,timeFrame,MacdFast,MacdSlow,1,MacdPrice,MODE_MAIN,y);
      y = iBarShift(SecondSymbol,timeFrame,Time[i]); buffer2[i] = iMACD(SecondSymbol,timeFrame,MacdFast,MacdSlow,1,MacdPrice,MODE_MAIN,y);
   
         if (timeFrame <= Period() || !Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //
      
         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               buffer1[i+k] = buffer1[i] +(buffer1[i+n]-buffer1[i])*k/n;
               buffer2[i+k] = buffer2[i] +(buffer2[i+n]-buffer2[i])*k/n;
            }               
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void showSymbol(string add, string symbol, int ypos, color theColor)
{
   int window = WindowFind(indicatorScreenName);
   string name;
          name = UniqueID+":"+add;
            ObjectCreate(name,OBJ_LABEL,window,Time[0],0);
               ObjectSet(name, OBJPROP_XDISTANCE, 10);
               ObjectSet(name, OBJPROP_YDISTANCE, ypos);
               ObjectSet(name, OBJPROP_COLOR,theColor);
               ObjectSet(name, OBJPROP_CORNER,1);
               ObjectSetText(name,symbol,9,"Arial bold");
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

